* convert Shift_JIS line to JIS
*  (with kana to 2byte code version)
*
* this source is 'free' and 'not guaranteed'
* 14, Feb, 2000 Rick <shonma@geocities.co.jp>
*
* (usege)
*	int sjis2jis(char *dest, char *src);
*
* (arguments)
*	dest ... pointer to destination buffer
*	src  ... pointer to source buffer
*
* (return value)
*	number of processed characters
*

	.cpu 68000

ESC	equ	$1b

	.text

	.even
	.globl _sjis2jis
_sjis2jis:
	movem.l 4(sp),a0/a1	*dest, src
	movem.l	d3/d4/a3/a4,-(sp)
	st.b	d2		*prev code = ascii
	clr.w	d0
	lea.l	codetype(OPC),a2
	lea.l	ktoz(OPC),a3
loop:
	move.b	(a1)+,d0	*(c = *r++) != NULL ?
	move.b	(a2,d0.w),d1	*current code == kana ?
*ifdef X68k
	ble	@f

	cmpi.b	#8,d1		*1byte kana ?
	bne	kana

	move.b	(a1)+,d0
	move.b	(a2,d0.w),d1	*current code == kana ?
*endif X68k
	bgt	kana
@@
	bne	ascii

	tst.b	d2
	beq	prev_kanji

	move.b	#ESC,(a0)+	*start_kanji
	move.b	#'$',(a0)+
	move.b	#'B',(a0)+
	move.b	d1,d2		*prev code = current code
prev_kanji:
	sub.b	#$71,d0		*jh -= 0x71
	cmpi.b	#$6e,d0		*jh <= 0x6e ?
	bls	@f

	sub.b	#$40,d0		*jh -= 0x40
@@
	add.b	d0,d0		*jh += jh
	addq.b	#1,d0		*jh++

	move.b	(a1)+,d1	*jl = *r++
	sub.b	#$1f,d1		*(jl -= 0x1f) <= 0x7f ?
	bpl	@f

	addq.b	#1,d0		*jh++
	sub.b	#$7e-$1f,d1	*jl -= 0x7e - 0x1f
	bra	putkanji
@@
	cmpi.b	#$7f-$1f,d1	*jl <= 0x7f - 0x1f ?
	bls	putkanji

	subq.b	#1,d1		*jl--
putkanji:
	move.b	d0,(a0)+	* *w++ = jh
	move.b	d1,(a0)+	* *w++ = jl
	bra	loop
ascii:
	tas.b	d2		*prev code == ascii ?
	bne	@f

	move.b	#ESC,(a0)+	*end_kanji
	move.b	#'(',(a0)+
	move.b	#'B',(a0)+
@@
	move.b	d0,(a0)+	* *w++ = c
	beq	end_sjis2jis

	move.b	d1,d2		*prev code = current code
	bra	loop
kana:
	tst.b	d2		*prev code = kanji ?
	beq	@f
*start_kanji
	move.b	#ESC,(a0)+
	move.b	#'$',(a0)+
	move.b	#'B',(a0)+
@@
	moveq.l	#0,d4		*dakuten offset = 0
	move.b	(a1),d3		*next chr
	cmpi.b	#'',d3
	bne	dakuten

	cmpi.b	#3,d1		*!handakuten ?
	bne	putkana

	moveq.l	#2,d4		*dakuten offset = 2
	bra	@f
dakuten:
	cmpi.b	#'',d3
	bne	putkana

	andi.b	#2,d1		*!dakuten ?
	beq	putkana

	moveq.l	#1,d4		*dakuten offset = 1
@@
	addq.w	#1,a1
putkana:
	sub.b	#$a0,d0
	add.b	d0,d0
	lea.l	(a3,d0.w),a4
	move.b	(a4)+,(a0)+
	add.b	(a4)+,d4
	move.b	d4,(a0)+
	sf.b	d2		*prev code = kanji
	bra	loop

end_sjis2jis:
	movem.l	(sp)+,d3/d4/a3/a4
	move.l	a0,d0		*w
	sub.l	4(sp),d0	*w - dest
	rts

	.even

*-1 ascii
* 0 Shift_JIS 1st
* 1 kana normal
* 2 kana dakuten
* 3 kana handakuten
* 8 2byte ascii/kana

codetype:
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.dc.b	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.dc.b	 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
	.dc.b	 1, 1, 1, 2, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.dc.b	 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 1
	.dc.b	 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
	.dc.b	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.dc.b	 8, 8, 8, 8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
ktoz:
	.dc.b	'@BuvAE@BDFHb'
	.dc.b	'[ACEGIJLNPRTVXZ\'
	.dc.b	'^`cegijklmnqtwz}'
	.dc.b	'~JK'

	.even
	.end
